"CATPlots" <- function(object,cond,minGenes=25,maxGenes=1000,upsideDown=FALSE){
		
	"CATPlots.default" <- function(table.signal,cond,minGenes,maxGenes,upsideDown){
	require(combinat)|| stop("cannot load applera without combinat")
	
	#It controls the number of treated
	if(length(which((cond)%in%1))==1){
		return("It is impossible to design CATPlots, you have only one treated!")
	}
	
	#It controls the number of treated
	if(length(cond)!=dim(table.signal)[2]){
		return("It is impossible to design CATPlots,the length of vector is different respect number of the column of the object!!")
	}	
	
	#reformat input table
	nomecolonne=c(colnames(table.signal)[which((cond)%in%0)],colnames(table.signal)[which((cond)%in%1)])
	table.signal1=cbind(table.signal[,which((cond)%in%0)],table.signal[,which((cond)%in%1)])
	colnames(table.signal1)=nomecolonne	
	
	lunCrt<-length(which(cond==0))
	tabFoldChange<- NULL
	w=0
	r2<- NULL
	nameex<- NULL
	for(j in 1:lunCrt){
		nomecol<-colnames(table.signal1)[j]
		for( i in (lunCrt+1) : (length(cond))) {
		nomecol2<-colnames(table.signal1)[i]
		w=w+1
		x<- (table.signal1[,i])-(table.signal1[,j])
	  	tabFoldChange<- cbind(tabFoldChange,x)
	  	colnames(tabFoldChange)[w]=paste(nomecol,nomecol2,sep=".")}
	  	row.names(tabFoldChange)=row.names(table.signal)
	  	
	}
	
	#It computes fold change and creates table with name genes ordered by value of fold change
	tabGeniOrd<- NULL
	
	for (k in 1 : (dim(tabFoldChange)[2])){
		tabSort<- sort((abs(tabFoldChange[,k])),decreasing = T)
		tabGeniOrd<- cbind(tabGeniOrd,names(tabSort))
		colnames(tabGeniOrd)[k]=paste(colnames(tabFoldChange)[k])
	}
		 
	#It computes combination
	cont<-0
	h<-1
	ht<- length(which(cond==1))
	comb<-NULL
	for (j in 1:length(which(cond==0))){
	 	
	 	comb<-cbind(comb,combn(colnames(tabGeniOrd)[h:ht],2))
	  	h<- h+length(which(cond==1))
	  	ht<- ht+length(which(cond==1))
	 } 
		

	#It computes intersection and designes CAT plot, in this case one color correspond to one reference
	
	if(upsideDown){
		par(mfrow=c(1,2))
	}
	plot(minGenes:maxGenes,minGenes:maxGenes,ylim=c(0,1),xlim=c(minGenes,maxGenes),xlab="Size of list",ylab="Proportion in common",bty="l")
	ff<-1
	NomeCol= comb[1,1]
	nomeCrt<-strsplit(NomeCol,"\\.")
	vetNomiCrt<- nomeCrt[[1]][1]
	vetNomiTrt<- nomeCrt[[1]][2]
	vetCol<- 1
	vetLinea<- 1
	ordinata1= NULL
	vria<- 0
	crtCol<- 1
	tabordinata= NULL
	
	
 	for( r in 1: (dim(comb)[2])){
 	
 		ordinata<- NULL
 		ascissa<-c(minGenes:maxGenes)
		for (j in minGenes:maxGenes){
			ordinata1<- c(ordinata1, length( intersect(tabGeniOrd[1:j,comb[1,r]], tabGeniOrd[1:j,comb[2,r]]))/j)
			ordinata<- c(ordinata, length( intersect(tabGeniOrd[1:j,comb[1,r]], tabGeniOrd[1:j,comb[2,r]]))/j)
		}
	
	NomeColCrt= comb[1,r]
	nomeCrtDoppio<-strsplit(NomeColCrt,"\\.")
		
	#to change color	
	if( nomeCrt[[1]][1]!= nomeCrtDoppio[[1]][1]){
		NomeCol= comb[1,r]
		nomeCrt<-strsplit(NomeCol,"\\.")
		crtCol=crtCol+1
		vetCol<-c(vetCol,crtCol)
	}
	lines(ascissa, ordinata, col=crtCol)
	vetNomiCrt= colnames(table.signal)[which(cond==0)]
	legend(25,1.05,vetNomiCrt,col=vetCol[1:(length(which(cond==0)))],lwd=2,lty=1,bty="n")
	}
	
	#It computes the correlation(r2) among the references using row data

	colonnectr<- NULL
	combr2<- NULL
	tabr2<- NULL
	nameexp<- NULL
	colonnectr<- cbind(colonnectr,table.signal1[,(which((cond)%in%0))])
	if(length((which((cond)%in%0)))==1){
	resultR2Contr<-"Not Computed"
	} else if(length(colnames(colonnectr))==2){
		tabr2<-summary(lm(colonnectr[,1]~colonnectr[,2]))$adj.r.squared
		nameexp<- paste(colnames(colonnectr)[1],colnames(colonnectr)[2],sep=" vs ")
		resultR2Contr<- data.frame(experiments=nameexp,correlations=tabr2)
	} else {
		combr2<-combn(colnames(colonnectr),2)
		for (rr in 1: (dim(combr2)[2])){
		tabr2<-c(tabr2,summary(lm(colonnectr[,(combr2[1,rr])]~colonnectr[,(combr2[2,rr])]))$adj.r.squared)
		nameexp<- c(nameexp,paste(combr2[1,rr],combr2[2,rr],sep=" vs "))
		}
		resultR2Contr<- data.frame(experiments=nameexp,correlations=tabr2)
	}
	
	#It computes the correlation(r2) among the treated using row data	
	colonnetrt<- NULL
	combr2tr<- NULL
	tabr2tr<- NULL
	nameexptr<- NULL
	colonnetrt<- cbind(colonnetrt,table.signal[,(which((cond)%in%1))])
	if(length(which((cond)%in%1))==1){
	resultR2Trat= "Not Computed"
	
	} else if(length(which((cond)%in%1))==2){
		tabr2tr<-summary(lm(colonnetrt[,1]~colonnetrt[,2]))$adj.r.squared
		nameexptr<-paste(colnames(colonnetrt)[1],colnames(colonnetrt)[2],sep=" vs ")
		resultR2Trat<- data.frame(experiments=nameexptr,correlations=tabr2tr)	
	} else {
		combr2tr<-combn(colnames(colonnetrt),2)
		for (xx in 1: (dim(combr2tr)[2])){
		tabr2tr<-c(tabr2tr,summary(lm(colonnetrt[,(combr2tr[1,xx])]~colonnetrt[,(combr2tr[2,xx])]))$adj.r.squared)
		nameexptr<- c(nameexptr,paste(combr2tr[1,xx],combr2tr[2,xx],sep=" vs "))
		}
		resultR2Trat<- data.frame(experiments=nameexptr,correlations=tabr2tr)	
	
	}
	if(!upsideDown){
		return (list(resultR2Ctrl=resultR2Contr,resultR2Trt=resultR2Trat))
	}
	
		 
	 #It designs CAT Plot upside down comb vector, in this case one color correspond to one treated
	 
if(upsideDown){

	#reformat input table
	nomecolonne=c(colnames(table.signal)[which(!(cond)%in%0)],colnames(table.signal)[which((cond)%in%0)])
	table.signal1=cbind(table.signal[,which(!(cond)%in%0)],table.signal[,which((cond)%in%0)])
	
	colnames(table.signal1)=nomecolonne	
		
	luntrt<-length(which(cond==1))
	tabFoldChange<- NULL
	w=0
	r2<- NULL
	nameex<- NULL
	for(j in 1:luntrt){
		nomecol<-colnames(table.signal1)[j]
		for( i in (luntrt+1) : (length(cond))) {
			nomecol2<-colnames(table.signal1)[i]
			w=w+1
			x<- (table.signal1[,i])-(table.signal1[,j])
	  		tabFoldChange<- cbind(tabFoldChange,x)
	  		colnames(tabFoldChange)[w]=paste(nomecol,nomecol2,sep=".")}
	  		row.names(tabFoldChange)=row.names(table.signal)
	  	}
	  	
	#It resort fold change table
	tabGeniOrd<- NULL
	
	for (k in 1 : (dim(tabFoldChange)[2])){
		tabSort<- sort((abs(tabFoldChange[,k])),decreasing = T)
		tabGeniOrd<- cbind(tabGeniOrd,names(tabSort))
		colnames(tabGeniOrd)[k]=paste(colnames(tabFoldChange)[k])
	}
		 
	#It computes combination
	cont<-0
	h<-1
	ht<- length(which(cond==0))
	comb<-NULL
	for (j in 1:length(which(cond==1))){
	 	
	 	comb<-cbind(comb,combn(colnames(tabGeniOrd)[h:ht],2))
	  	h<- h+length(which(cond==0))
	  	ht<- ht+length(which(cond==0))
	 } 
		

	
	#It computes intersection and designes CAT plot, in this case one color correspond to one reference	 
	plot(minGenes:maxGenes,minGenes:maxGenes,ylim=c(0,1),xlim=c(minGenes,maxGenes),xlab="Size of list",ylab="Proportion in common",bty="l")
	ff<-1
	NomeTrt= comb[2,1]
	nomeTrt<-strsplit(NomeTrt,"\\.")
	vetCol<-1
	ordinata1= NULL
	vria<- 0
	trtCol<- 1
	tabordinata= NULL
	
	
 	for( r in 1: (dim(comb)[2])){
 	
 		ordinata<- NULL
 		ascissa<-c(minGenes:maxGenes)
		for (j in minGenes:maxGenes){
			ordinata1<- c(ordinata1, length( intersect(tabGeniOrd[1:j,comb[1,r]], tabGeniOrd[1:j,comb[2,r]]))/j)
			ordinata<- c(ordinata, length( intersect(tabGeniOrd[1:j,comb[1,r]], tabGeniOrd[1:j,comb[2,r]]))/j)
		}
		
		NomeColTrt= comb[2,r]
		nomeTrtDoppio<-strsplit(NomeColTrt,"\\.")
		
	if( nomeTrt[[1]][1]!= nomeTrtDoppio[[1]][1]){
		NomeTrt= comb[2,r]
		nomeTrt<-strsplit(NomeTrt,"\\.")
		trtCol=trtCol+1
		vetCol<-c(vetCol,trtCol)
	}
	lines(ascissa, ordinata, col=trtCol)
	vetNomiTrt= colnames(table.signal)[which(!(cond==0))]
	legend(25,1.05,vetNomiTrt,col=vetCol[1:(length(which(!(cond==0))))],lwd=2,lty=1,bty="n")
	}
}
	return (list(resultR2Ctrl=resultR2Contr,resultR2Trt=resultR2Trat))
}
myexp=is(object, "matrix")
myapp=is(object, "applera")	


if (myexp) {
		table.signal=object
		CATPlots.default(table.signal,cond,minGenes,maxGenes,upsideDown)
	} else {if (myapp) {
		table.signal=exprs(signal(object))
		CATPlots.default(table.signal,cond,minGenes,maxGenes,upsideDown)
	} else{
		table.signal=exprs(object)
		CATPlots.default(table.signal,cond,minGenes,maxGenes,upsideDown)
	}}
}



	