 
 #library(applera)
 #data(test)
#########################################################à
#this function optimize filtering using two class experiments and linear model analysis
#Filtering is based S/N and iqr
#apObj is an applera object
#covariate is the covariate that allows the definitin of the two classes
#sn.value indicate the threshold for S/N ratio to be considered  indicate 99.9% confidence that the signal is different from bg
#p indicate the set of % of experiments characterized by a specific sn value
# iqr.value indicate the threshold for the IQR of the gene under analysis
"optFilter" <- function(apObj, covariate, sn.value=3, p=c(1, 0.75, 0.5, 0.25), iqr.value=c(0.5, 0.25)){
               require(limma)  || stop("cannot load optFilter without limma")
               groups <- pData(signal(apObj))[[covariate]]
               design <- model.matrix(~ -1+factor(groups))
               colnames(design) <- c("s1","s2")
               z <- 1
               my.filter.names <- NULL
               my.filter <- NULL
               for (i in p){
                         for(j in iqr.value){
                             sn.subset <- apFilter(apObj, i, sn.value, "sn")#filtering by sn
                             iqr.sn.subset<-iqrFilter(sn.subset,j)#filtering by iqr
                             iqr.sn.signal <- signal(iqr.sn.subset)
                             fit <- lmFit(iqr.sn.signal, design, method="ls")
                             contrast.matrix <- makeContrasts(s2-s1, levels=design)
                             fit2 <- contrasts.fit(fit, contrast.matrix)
                             eb <- eBayes(fit2)
                             eb.decideTests <- decideTests(eb,method="separate",adjust.method="fdr",p.value=0.05)
                             tmp <- length(which(eb.decideTests != 0))
                             my.filter.names[z] <- paste("S/N", i, "IQR", j, collapse=" ")
                             z <- z + 1
                             my.filter <- c(my.filter, tmp)
                        }
               }
               names (my.filter) <- my.filter.names
               cat("The best integration od sn and iqr filtering conditions, giving the max number of DE genes is \n\t", names(my.filter)[my.filter==max(my.filter)],"\n\t",max(my.filter)," genes\n")
	       parameters <- strsplit(names(my.filter)[my.filter==max(my.filter)], " ")
               sn.subset <- apFilter(apObj, as.numeric(parameters[[1]][2]), sn.value, "sn")#filtering by sn
               iqr.sn.subset<-iqrFilter(sn.subset,as.numeric(parameters[[1]][4]))#filtering by iqr  
	       return(iqr.sn.subset)      
}

#tmp.1 <- optFilter(test, "wk" , sn.value=3, p=c(1, 0.75, 0.5, 0.25), iqr.value=c(0.5, 0.25))


##################################################################################################
