#creating an istance of the applera class starting from a phenodata file and a set of 
#applera files containing the following columns:probe id, raw signal, SDEV, CV, SN, Flag
#the phenodata has to contain as row the applera file names
#the organism should be Hs or Mm or Rn
#this function create also the applera class and some methods
"readAp" <- function(pd, organism){
                 require(Biobase)
                 require(affy)
                 tmp.pd <- read.phenoData(filename = pd)
                 arrayNames <- rownames(pData(tmp.pd))
                 arraydata <- NULL
                 geneId <- NULL
                 signal.tmp <- NULL
                 sdev.tmp <- NULL
                 cv.tmp <- NULL
                 sn.tmp <- NULL
                 flags.tmp <- NULL
                 ctrl.tmp <- NULL
                 if(organism=="Mm") size=33012
                 if(organism=="Hs.v1") size=33096
                 if(organism=="Hs.v2") size=32878 
                 if(organism=="Rn") size=NULL
 
                 for(i in arrayNames){
                       arraydata<-read.table(i, sep="\t", header=T, row.names=1)
		       #the array data structure is a table with 7 columns:
		       #        ProbeID (row.names), 
		       #        geneID, 
		       #        Signal, 
		       #        Sdev, 
		       #        Cv, 
		       #        Sn, 
		       #        Flags
                       geneId<-as.character(arraydata[,1])#they should be identical for all arrays
                       signal.tmp<-cbind(signal.tmp, as.numeric(arraydata[,2]))
                       #column 2 is the primary geneID
                       sdev.tmp<-cbind(sdev.tmp, as.numeric(arraydata[,3]))
                       cv.tmp<-cbind(cv.tmp, as.numeric(arraydata[,4]))
                       sn.tmp<-cbind(sn.tmp, as.numeric(arraydata[,5]))
                       flags.tmp<-cbind(flags.tmp, as.numeric(arraydata[,6]))
                 }
                 geneId<-as.character(geneId[1:size])
                 signal.tmp <- as.data.frame(signal.tmp)
                 rownames(signal.tmp)<-rownames(arraydata)
                 ctrlS <- log2(signal.tmp[(size+1): dim(signal.tmp)[1],])
                 names(ctrlS) <- arrayNames
                 #ctrlS is not logged!
                 signal.tmp <- log2(signal.tmp[1:size,])#the signal is logged not the ctrl
                 sdev.tmp<-as.data.frame(sdev.tmp)
                 rownames(sdev.tmp)<-rownames(arraydata)
                 ctrlSd <- sdev.tmp[(size+1): dim(sdev.tmp)[1],]
                 names(ctrlSd) <- arrayNames
                 sdev.tmp <- sdev.tmp[1:size,]
                 cv.tmp<-as.data.frame(cv.tmp)
                 rownames(cv.tmp)<-rownames(arraydata)
                 ctrlCv <- cv.tmp[(size+1): dim(cv.tmp)[1],]
                 names(ctrlCv) <- arrayNames
                 cv.tmp <- cv.tmp[1:size,]
                 sn.tmp<-as.data.frame(sn.tmp)
                 rownames(sn.tmp)<-rownames(arraydata)
                 ctrlSn <- sn.tmp[(size+1): dim(sn.tmp)[1],]
                 names(ctrlSn) <- arrayNames
                 sn.tmp <- sn.tmp[1:size,]
                 flags.tmp<-as.data.frame(flags.tmp)
                 rownames(flags.tmp)<-rownames(arraydata)
                 ctrlF <- flags.tmp[(size+1): dim(flags.tmp)[1],]
                 names(ctrlF) <- arrayNames
                 ctrl.tmp<-list("signal"=ctrlS, "sdev"=ctrlSd, "cv"=ctrlCv, "sn"=ctrlSn, "flags"=ctrlF)
                 flags.tmp <- flags.tmp[1:size,]

                 testFile <- tempfile()
	         #write.table(ctrl, testFile, quote = FALSE, sep = "\t", row.names =TRUE, col.names=TRUE)
	         #ctrl<-read.exprSet(testFile, phenoData=pd)
                 #sampleNames(ctrl)<-arrayNames
                 testFile <- tempfile()
	         write.table(signal.tmp, testFile, quote = FALSE, sep = "\t", row.names =TRUE, col.names=TRUE)
	         signal.tmp<-read.exprSet(testFile, phenoData=pd)
                 sampleNames(signal.tmp)<-arrayNames
                 testFile <- tempfile()
	         write.table(sdev.tmp, testFile, quote = FALSE, sep = "\t", row.names =TRUE, col.names=TRUE)
	         sdev.tmp<-read.exprSet(testFile, phenoData=pd)
                 sampleNames(sdev.tmp)<-arrayNames
                 testFile <- tempfile()
	         write.table(cv.tmp, testFile, quote = FALSE, sep = "\t", row.names =TRUE, col.names=TRUE)
	         cv.tmp<-read.exprSet(testFile, phenoData=pd)
                 sampleNames(cv.tmp)<-arrayNames
                 testFile <- tempfile()
	         write.table(sn.tmp, testFile, quote = FALSE, sep = "\t", row.names =TRUE, col.names=TRUE)
	         sn.tmp<-read.exprSet(testFile, phenoData=pd)
                 sampleNames(sn.tmp)<-arrayNames
                 testFile <- tempfile()
	         write.table(flags.tmp, testFile, quote = FALSE, sep = "\t", row.names =TRUE, col.names=TRUE)
	         flags.tmp<-read.exprSet(testFile, phenoData=pd)
                 sampleNames(flags.tmp)<-arrayNames
                 myclass<-new("applera")
                 myclass@Organism<-organism
                 myclass@Geneid<-geneId
                 myclass@Signal<-signal.tmp
                 myclass@Sdev<-sdev.tmp
                 myclass@Cv<-cv.tmp
                 myclass@Sn<-sn.tmp
                 myclass@Flags<-flags.tmp
                 myclass@Ctrl<-ctrl.tmp
                 return(myclass)
}

 
