\name{CATPlots}
\alias{CATPlots}
\title{CATplots is a quality control function to evaluate replicates quality}
\description{
This function is used to evaluate the quality of biological replicates using the CAT plots originally develped by Irizarry in Nature Methods 2005.
The function has been build for comparing replicate quality in a two groups experiment (e.g. test set vs reference set).
}
\usage{
CATPlots(object, cond, minGenes=25, maxGenes=1000, upsideDown=FALSE)
}
\arguments{
  \item{object}{An applera object, or an exprSet object or a matrix of expression values, where columns are arrays replicates and rows are genes.}
  \item{cond}{A vector of 0 and 1, where 1 indicates the group of test arrays (Trt) to be evaluated with respect to a group of reference arrays (Ctrl) indicated by 0.}
  \item{minGenes}{Min number of genes to be used to create the gene lists. For more information see the applera vignette.}
  \item{maxGenes}{Max number of genes to be used to create the gene lists. For more information see the applera vignette.}
  \item{upsideDown}{A logical parameter that allows to perfome CATplots also on the reversed condition vector, where 0s are now 1s and 1s are 0s.}
}
\details{
 See applera vignette
}
\value{
  Results are represented as plots and the function returns a list.
  \item{resultR2Trt }{R-squared correlation among Trt data.}
  \item{resultR2Crt }{R-squared correlation among Ctrl data.}

}
\references{}
\author{ Francesca Cordero <fcordero@di.unito.it> }
\note{}
}
\examples{
# data(test)
# tmp1 <- exprs(signal(test))
# tmp2 <- CATPlots(tmp1, c(0,0,0,1,1,1), 1, 1000, FALSE)
}
\keyword{misc}
