\name{readAp}
\alias{readAp}
\alias{readAp}
\title{Function to load applera array data in a applera object}
\description{
  The function \code{readAp} expects two variables a phenodata file name, containing, as rownames, the applera file names and an organism string (Hs, Mm, Rn) that define the characteristics of the arrays to be loaded. The function will load in an applera object all the files present in the working directory having the same names as the rownames of the phenoData file. To be loaded the results from the AB1700 analysis has to be organized to have a file for each array result. The file should contain in the following order: ProbeID, GeneID, Signal, SDEV, CV, SN and Flags.}
\usage{
readAp(pd, organism)
}
\arguments{
  \item{pd}{the name of the phenodata file}
  \item{organism}{"Hs.v1" or "Hs.v2" for human, "Mm" for mouse or "Rn" for rat}
}
\value{
  An object of class "applera".
}
\author{Raffaele A. Calogero <Raffaele.Calogero@unito.it>, francesca Cordero <fcordero@di.unito.it>}
\seealso{\code{\link{applera-class}} for the class of the return value.
}
\examples{
#
}
\keyword{classes}
